var express = require('express')
var xml = require('xml')
var router = express.Router()

var libs = process.cwd() + '/libs/'

var log = require(libs + 'log')(module)
var config = require(libs + 'config')

var conn = require(libs + 'db/monet')

router.get('/', function(req, res) {
  conn.query(
    'SELECT * FROM municipios', true
  ).then(function(result) {
    log.debug(result)
    if (req.query.format === 'csv') {
      res.csv(result.data)
    } else if (req.query.format === 'xml') {
      res.set('Content-Type', 'text/xml')
      res.send(xml({
        result: result.data
      }))
    }
    else {
      res.json({
          result: result.data
      })
    }
  })

})

router.get('/:id', function(req, res) {
  conn.query(
    'SELECT * FROM municipios WHERE pk_municipio_id='+req.params.id, true
  ).then(function(result) {
    log.debug(result)
    if (req.query.format === 'csv') {
      res.csv(result.data)
    } else if (req.query.format === 'xml') {
      res.set('Content-Type', 'text/xml')
      res.send(xml({
        result: result.data
      }))
    }
    else {
      res.json({
          result: result.data
      })
    }
  })
})

router.get('/ibge/:id', function(req, res) {
  conn.query(
    'SELECT * FROM municipios WHERE codigo_ibge='+req.params.id, true
  ).then(function(result) {
    log.debug(result)
    if (req.query.format === 'csv') {
      res.csv(result.data)
    } else if (req.query.format === 'xml') {
      res.set('Content-Type', 'text/xml')
      res.send(xml({
        result: result.data
      }))
    }
    else {
      res.json({
          result: result.data
      })
    }
  })
})

router.get('/state/:id', function(req, res) {
  conn.query(
    'SELECT * FROM municipios WHERE fk_estado_id='+req.params.id, true
  ).then(function(result) {
    log.debug(result)
    if (req.query.format === 'csv') {
      res.csv(result.data)
    } else if (req.query.format === 'xml') {
      res.set('Content-Type', 'text/xml')
      res.send(xml({
        result: result.data
      }))
    }
    else {
      res.json({
          result: result.data
      })
    }
  })
})

module.exports = router
